
#ifndef SMART_OPC_SERVER_HPP
#define SMART_OPC_SERVER_HPP

#include <thread>
#include <chrono>
#include <string>

#include <opc/ua/node.h>
#include <opc/ua/subscription.h>
#include <opc/ua/server/server.h>

#include "SmgStateMachine.hpp"


class SmartOpcServer
{
public:
    SmartOpcServer(SmgStateMachine &state_machine);

    void run_server();

private:
    void setup_server();

    SmgStateMachine &m_state_machine;

    OpcUa::UaServer m_server;
    uint32_t m_idx; // namespace index in server
    OpcUa::Node m_objects_folder; // address space for node objects
    OpcUa::Node m_root_node;

    OpcUa::Node m_state;
    OpcUa::Node m_sun;
    OpcUa::Node m_wind;
    OpcUa::Node m_power_production;
    OpcUa::Node m_usage;
    OpcUa::Node m_excess_power;
    OpcUa::Node m_renewable_power;

    OpcUa::Node m_controls;
    OpcUa::Node m_time;
    OpcUa::Node m_producing;
    OpcUa::Node m_sim_mode_enabled;

    std::shared_ptr<spdlog::logger> m_logger;

};


#endif