///

#ifndef SMG_STATE_MACHINE_HPP
#define SMG_STATE_MACHINE_HPP

#include "SmartGridModel.hpp"
#include "HardwareControl.hpp"

enum class MainState
{
    Simulation,
    ManualControl
};

enum class SimState
{
    Entry,
    Do,
    Exit
};

enum class ManualState
{
    Entry,
    Do,
    Exit
};


class SmgStateMachine
{
public:
    SmgStateMachine(SmartGridModel &model);
    void run();
    bool is_sim_mode_enabled();
    void set_sim_mode_enabled(bool enable);

    SmartGridModel &m_model;
private:

    void simulation_state();
    void manual_state();


    bool m_state_machine_is_running {true};
    MainState m_main_state {MainState::Simulation};
    SimState m_sim_state {SimState::Entry};
    ManualState m_manual_state {ManualState::Entry};
};

#endif