/// @file   main.cpp
///
#include <thread>
#include <iostream>

#include "i2c/Node.hpp"
#include "HardwareControl.hpp"

#include "SmartGridModel.hpp"
#include "SmgStateMachine.hpp"
#include "SmartOpcServer.hpp"

/// @brief Log user inputs
///
void log_args(int argc, char **argv)
{

}

int main(int argc, char **argv)
{
    uint8_t slave_address{0x14};
    i2c::Node i2c_channel{slave_address};
    if (false == i2c_channel.open_device("/dev/i2c-1"))
    {
        exit(1);
    }

    HardwareControl hardware{i2c_channel};
    SmartGridModel model{hardware};
    SmgStateMachine stateMachine{model};


    SmartOpcServer server{stateMachine};
    std::cout << "OPC Server is running.." << std::endl;
    server.run_server();

    // spdlog::info("End");
    return 0;
}
