/// @file Protocol.hpp
///

#ifndef PROTOCOL_HPP
#define PROTOCOL_HPP

#include <string>

#include <com/Socket.hpp>

class IProtocol
{
public:
    IProtocol(DataSocket& socket);

    virtual void send_message(std::string const& url, std::string const& message) = 0;
    virtual void recv_message(std::string& message) = 0;
protected:
    DataSocket& m_socket;
};


class ProtocolSimple : public IProtocol
{
public:
    using IProtocol::IProtocol;
    void send_message(std::string const& url, std::string const& message) override;
    void recv_message(std::string& message) override;
};


#endif