/// @file ProtocolSgm.hpp
///


#ifndef PROTOCOL_SGM_HPP
#define PROTOCOL_SGM_HPP


#include <memory>
#include <vector>
#include <thread>


struct CommandSgm
{
    std::string cmd;
    std::string val;
    std::string ack;
};


class ProtocolSgm
{
public:
    ProtocolSgm(std::string const& address);
    void send_cmd(CommandSgm const& cmd);

    using QueueRef = std::shared_ptr<std::vector<CommandSgm>>;
    static const int sgm_com_port {8080};

private:
    void sending();
    void receiving();

    std::thread m_sending;
    std::thread m_receiving;
    std::string m_com_addr;
    QueueRef m_send_queue;
    QueueRef m_recv_queue;
};


#endif