/// @file sample_client.cpp
///


#include <com/Socket.hpp>
#include <com/Protocol.hpp>

#include <spdlog/spdlog.h>

int main(int argc, char** argv)
{
    spdlog::set_level(spdlog::level::debug);

    if (argc != 3)
    {
        spdlog::error("Usage: client <host> <Message>");
        std::exit(1);
    }


    ConnectSocket connect{argv[1], 8080};
    ProtocolSimple simple_connect{connect};

    simple_connect.send_message("", argv[2]);
    std::string message;
    simple_connect.recv_message(message);
    // spdlog::info("RECV: {}", message);
    return 0;
}